﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.HttpsPolicy;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace RestCustomerServiceCoreY
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddCors(); //then app.AddCors in Configure method

            //Alternatively define policies and use them in Configure for whole application.
            //OR spcifically for each controller and methods provided.
            //services.AddCors(options =>
            //{
            //    options.AddPolicy("AllowSpecificOrigin",
            //        builder => builder.WithOrigins("http://example.com"));

            //    options.AddPolicy("AllowAnyOrigin",
            //        builder => builder.AllowAnyOrigin());
            //options.AddPolicy("AllowAnyOriginGetPost",
            //    builder => builder.AllowAnyOrigin().WithMethods("GET", "POST"));

           // });



            services.AddMvc().SetCompatibilityVersion(CompatibilityVersion.Version_2_1);
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseHsts();
            }

           // app.UseCors("AllowAnyOrigin");  //Policy solution on app.
                                            // app.UseCors("AllowAnyOriginGetPost");



            //app.UseCors(
            //   options =>
            //   {
            //       options.AllowAnyOrigin().WithMethods("GET","POST"); // allow everything from anywhere

            //   });

            app.UseHttpsRedirection();
            app.UseCors(
              options =>
              {
                  options.AllowAnyOrigin().AllowAnyMethod(); // allow everything from anywhere
                  //options.WithOrigins("my.com").AllowAnyMethod();
                  //options.AllowAnyOrigin().WithMethods("GET", "POST");

               }
           

              );
           
            app.UseMvc();
        }
    }
}
